/*	slice.c	ver 0.30		*/
/*		Copyrigth 1998 Rick	*/

#include	<corlib.h>
#include	<parts.h>
#include	<winop.h>
#include	<string.h>
#include	<doslib.h>
#include	"picslice.h"

extern int loadPICfile();
extern int loadBMPfile();
extern 	int loadMAGfile();
extern int loadGIFfile();
extern int loadPifile();
extern void aspnormalize();
extern void putug( UGraphic* );
extern void SetPalet( unsigned short*, int );
extern int getgmode( unsigned short* );
extern void EndOfDraw();

void extraloader( WindowID, unsigned char*, unsigned char* );
int	popupmenu( WindowID, EventInfo* );
int	EXEC( WindowID, EventInfo* );

int	WindowHeapSize = 0*1024;

struct	_picsliceinfo	psi;
unsigned char	filename[90]= "\0",
	execom[90]= "\0",
	opt[128]= "\0";
char *gformat[]= { "PIC", "BMP", "MAG", "GIF", "JPG", "PI", "PNG" };
int	dy = 8,
	drawing = FALSE,
	redraw= FALSE,
	curgmode= 0,
	type= 0; /* PIC= 1, BMP= 2, MAG= 3, GIF= 4, JPG= 5, Pi= 6, PNG= 7, other= 0 */
int	gmode[3]= { WindowAttrGraphic16, WindowAttrGraphic256, WindowAttrGraphic65536 };
short	pat1[] = { 0x0000 };
short	pat2[] = { 0xffff };
Sheet	black = { 16, 1, 1, pat1, pat2 };
char	*menu[]= {	" G16 ON",
			"G256 ON",
			"G64k ON",
			" ReLoad",
			" 3 / 4"
		};
void	(*drawfunc)();
unsigned short pal16[]= {
	0x0000, 0x5294, 0x0020, 0x003e, 0x0400, 0x07c0, 0x0420, 0x07fe, 
	0x8000, 0xf800, 0x8020, 0xf83e, 0x8400, 0xffc0, 0xad6a, 0xfffe
};



void
extraloader( wp, comchar, optchar )
WindowID wp;
unsigned char *comchar;
unsigned char *optchar;
{
	char    buf[256];

	strcpy( buf, optchar );
	strcat( buf, filename );
	WindowLoadExec( comchar, buf, NULL, NULL );
	curgmode= getgmode( (unsigned short*)psi.colortable );
	psi.realwidth= curgmode? 512:1024;
	psi.width= psi.realwidth;
	psi.height= psi.realwidth;
	SetPalet( (unsigned short*)psi.colortable, 256 );
	WindowSetAttr( wp, gmode[curgmode] );
	WindowSetEventAttr( wp, EventAttrDefault|EventUserON|EventIconifyON );
	if( redraw ){
		WindowScreenInit();
	}else {
		WindowRedraw( wp );
	}
	return;
}

int
preparepsi( wp )
WindowID wp;
{
	char	*ext= NULL;
	int i, ret= PICSLICE_NORMAL;

	if ( drawing )		EndOfDraw();

	WindowSetBackPattern( &black );

	if( !filename[0] )
		return TRUE;
	if( !( ext= strrchr( filename, '.' ) ) ){
		type= 0;
	}else {
		for( i= 6; i > -1; i-- ){
			if( !( stricmp( ext+1, gformat[i] ) ) ){
				break;
			}
		}
		type= i + 1;
	}
	WindowSetEventAttr( wp, EventAttrDefault|EventUserON|EventIntervalON|EventIconifyON );
	if ( (psi.filehandle = OPEN( filename, 0 ) ) < 0 ){
		psi.filehandle= NULL;
		ret= PICSLICE_EREAD;
	}else {
		switch( type ){
		case 0:		/* other */
			extraloader( wp, execom, opt );
			break;
		case 1:		/* pic */
			curgmode= 2;
			SetPalet( (unsigned short*)psi.colortable, 256 );
			ret= loadPICfile();
			break;
		case 2:		/* bmp */
			ret= loadBMPfile();
			break;
		case 3:		/* mag */
			ret= loadMAGfile();
			break;
		case 4:		/* gif */
			ret= loadGIFfile();
			break;
		case 5:		/* jpg */
			curgmode= 2;
			SetPalet( (unsigned short*)psi.colortable, 256 );
			extraloader( wp, "jpeged.r", "-F3" );
			break;
		case 6:		/* Pi */
			ret= loadPifile();
			break;
		case 7:		/* PNG */
			curgmode= 2;
			WindowSetAttr( wp, gmode[curgmode] );
			SetPalet( (unsigned short*)psi.colortable, 256 );
			extraloader( wp, "pngl.x", " -a " );
			break;
		}
	}
	if( ret != PICSLICE_NORMAL ){
		ConsoleOpen();
		ConsolePrint( "slice: failed.\n" );
		extraloader( wp, execom, opt );
	}
	WindowSetAttr( wp, gmode[curgmode] );
	return ret;
}

int
popupmenu( wp, info )
WindowID	wp;
EventInfo	*info;
{
	int	n,px,py;
	
	WindowGetScreenPosition( wp, &px, &py );
	px+= info->x;
	py+= info->y;
	n= PopUpMenu( px-1, py, menu, sizeof menu/sizeof(char*), 12 );
	if( n < 0 || n > 4 )	return FALSE;
	switch( n ){
	case 3:
		preparepsi( wp );
		break;
	case 4:
		aspnormalize();
		if( curgmode == 2 ){
			WindowSetEventAttr( wp, EventAttrDefault|EventUserON|EventIntervalON|EventIconifyON );
		}
		break;
	default:
		curgmode = n;
		WindowSetBackPattern( &black );
		WindowSetAttr( wp, gmode[n] );
		SetPalet( (unsigned short*)psi.colortable, 256 );
		WindowRedraw( wp );
	}
	return TRUE;
}

int
Exec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[3];
	switch( info->option ){
	case EventInterval:
		if ( drawing ){
			(*drawfunc)();
			return	TRUE;
		}
		WindowSetEventAttr( wp, EventAttrDefault|EventUserON|EventIconifyON );		
		return FALSE;
	case EventUser:
		switch( info->ComData ){
		case UserGraphic:{
			UGraphic *gp= info->ComBuffer;
			int colnum= 256, i;
			unsigned short *wtpal= (unsigned short*)psi.colortable;
			unsigned short *rdpal= gp->palet;
			switch( curgmode= ((gp->color) >> 2 ) - 1 ){
				case 0:
					colnum= 16;
					if( !rdpal )	rdpal= pal16;
				case 1:
					for( i= 0; i < colnum; i++ ){
						*wtpal++= *rdpal++;
					};
					break;
			}
			SetPalet( (unsigned short*)psi.colortable, colnum );
			putug( gp );
			return TRUE;
		}
		case UserPaste:
		case UserString:
			strcpy( filename, info->ComBuffer );
			WindowRedraw( wp );
			preparepsi( wp );
			return TRUE;
		case UserStrings:
			strcpy( filename, *(char**)info->ComBuffer );
			WindowRedraw( wp );
			preparepsi( wp );
			return TRUE;
		}
		return FALSE;
	case EventOpen:
		curgmode = getgmode( (unsigned short*)psi.colortable );
		psi.realwidth= curgmode? 512:1024;
		psi.width= psi.realwidth;
		psi.height= psi.realwidth;
		WindowSetEventAttr( wp, EventAttrDefault|EventUserON|EventIconifyON );
		WindowSetAttr( wp, gmode[curgmode] );
		WindowRedraw( wp );
		preparepsi( wp );

		return	TRUE;
	case EventRedraw:
		DrawSetClear( dbuf, 1 );
		DrawSetLine( dbuf+1, 1, 1, 145, 15, ShadowDown, OptionShadow );
		DrawSetSymbol( dbuf+2, 3, 2, filename, AttrDefault, 12 );
		WindowDraw( wp, dbuf, 3 );
		return	TRUE;
	case EventClose:
		if ( drawing )
			EndOfDraw();
		WindowSetBackPattern( 0 );
		WindowClose( wp );
		WindowConnectionClose();
		return	TRUE;
	case EventIconify:
		IconEnt( wp, "slice", 9 | AttrHighLight, 12 );
		return TRUE;
	case EventMouseSwitch:
		if( info->RightON ){
			popupmenu( wp, info );
			return TRUE;
		}
	}
	return	FALSE;
}

int
WindowMain( argc, argv )
int	argc;
char	**argv;
{
	int	x= 150, y= 110, pid, pct= -1;
	unsigned int	infop= 0;
	char	pname[]= "slice.win";
	EventInfo myinfo;
	WindowID	wp;

	psi.filebuf = NULL;
	psi.chainbuf = NULL;
	psi.filehandle = 0;
	argc= AnalyzeArgs( argc, argv, &x, &y, NULL, NULL );
	while( --argc ){
		if( **++argv != '-' ){
			strcpy( filename, *argv );
			break;
		}else if( (*argv)[1] == 'r' ){
			dy= atoi2( *argv+2 );
		}else if( (*argv)[1] == 'U' ){
			char	table[]= "0123456789ABCDEF",
			*str= *argv + 2;

	    	while( *str ){
				int	i;
		   		for( i= 0; i < 16; i++ ){
					if( *str == table[i] ){
				    	infop<<= 4;
						infop+= i;
						break;
					}
				}
				if( i == 16 ){
					infop= 0;
					break;
				}
				++str;
			}
		}
	}

	for( pid= 0; pid= PidSearch( pname, pid+1 ); )	pct++;
	if( pct ){
		if( filename[0] ){
			myinfo.option= EventUser;
			myinfo.ComData= UserString;
			myinfo.ComBuffer= filename;
			PidSendEvent( pname, &myinfo, TRUE );
		}
		WindowConnectionClose();
		return TRUE;
	}
	if( !CommonOpen( "SLICE" ) ){
		ConsoleOpen();
		ConsolePrint( "slice: no config\n" );
	}else {
		CommonGetWord( execom );
		if( execom[0] == '$' ){
			redraw= TRUE;
			execom[0] = ' ';
		}
		CommonGetWord( opt );
		if( opt[0] )	strcat( opt, " " );
	}
	wp= WindowTitleOpen( x, y, 146+2, 16+2, NULL, "Ko-slice", Push|Close|Icon, Exec );
	if( infop )	WindowSendEvent( wp, (EventInfo*)infop );
	return TRUE;
}
